;*********************************************************
;DDS AD9851 SG No.81
;CPU AT90S4414	   2005.7.14  BY JE1UCI
;LCD 16*2
;ATT CTL
;*********************************************************

.include "4414def.inc"

;**** regster set ****
.DEF		AR0	= R00		;FRQ DATA 10MHz
.DEF		AR1	= R01		;FRQ DATA 1MHz
.DEF		AR2	= R02		;FRQ DATA 100KHz
.DEF		AR3	= R03		;FRQ DATA 10KHz
.DEF		AR4	= R04		;FRQ DATA 1KHz
.DEF		AR5	= R05		;FRQ DATA 100Hz
.DEF		AR6	= R06		;FRQ DATA 10Hz
.DEF		AR7	= R07		;FRQ DATA 1Hz
.DEF		AR8	= R08		;FRQ DATA 0.1Hz
.DEF		AR9	= R09		;FRQ DATA 0.01Hz
.DEF		FLAG_B	= R10		;MSB[RENA,RENB,X,X,  X,X,X,X]LSB
.DEF		REG_SAVE= R11		;for ATTIMER
.DEF		TM_COUNT= R12
.DEF		INIT_VALUE=R13
.DEF		ATTIMER	=R14		;1=CHK 0=NO CHK

.DEF		DBM	= R16		;SG OUTPUT LEVEL(-dBm)
.DEF		DBU	= R17		;SG OUTPUT LEVEL(dBu)
.DEF		ATT	= R18		;ATT(dB)
.DEF		DAR0	= R19 		;DDS DATA
.DEF		DAR1	= R20
.DEF		DAR2	= R21
.DEF		DAR3	= R22
.DEF		STEP	= R23
.DEF		FLAG_A	= R24		;MSB[X,X,X,X,  X,X,RENA,RENB]LSB
.DEF		TEMPA	= R25		;TEMPA REG
.DEF		TEMPB	= R26		;TEMPB REG
.DEF		TEMPC	= R27		;TEMPC REG
;		YL=Y	= R28		;
;		YH	  R29		;
;		ZL=Z	= R30		;
;		ZH	  R31		;
;	STACK POINT	$DF

;************************* Vector Address ************************
.cseg					; code segment is from here
.org 0
 		RJMP	RESET 		; reset handler
		RETI			; irq0 handler
		RETI			; irq1 handler
		RETI 			; timer1 capture handler
 		RETI 			; timer1 comparea handler
 		RETI 			; timer1 compareb handler
 		RETI			; timer1 overflow handler
 		RJMP	ATTIMER	 	; timer0 overflow handler
 		RETI 			; spi transfer complete handler
 		RETI 			; uart rx complete handler
		RETI 			; udr empty handler
		RETI			; uart tx complete handler
		RETI			; analog comparator handler

;*****************************************************************
 RESET:		LDI	ATT,$00		;ATT=0dB
		LDI	FLAG_A,$00	;FLAG_A=CLEAR
		LDI	TEMPA,$0C	;TEMPB START=$0C
		MOV	FLAG_B,TEMPA
		LDI	TEMPA,$00	;TEMPA=CLEAR
		LDI	R31,$00		;ZH=CLEAR
		LDI	DAR0,$00
		LDI	DAR1,$00
		LDI	DAR2,$00
		LDI	DAR3,$00
		LDI	STEP,$05	;START =100kHz STEP
		LDI	TEMPA,$DF	;STACK POINT SET
		OUT	SPL,TEMPA
		LDI	TEMPA,$00
		MOV	ATTIMER,TEMPA
		LDI	TEMPA,$05
		OUT	TCCR0,TEMPA
		LDI	TEMPA,$83
		MOV	INIT_VALUE,TEMPA
		OUT	TCNT0,INIT_VALUE
		LDI	TEMPA,$02
		OUT	TIMSK,TEMPA
		CLR	TM_COUNT
		SEI

;*** PORT SET ****************************************************
		LDI	TEMPA,$00
		OUT	DDRA,TEMPA	;PORTA IN
		LDI	TEMPA,$FC
		OUT	PORTA,TEMPA	;PORTA 2-7 PULL UP
		LDI	TEMPA,$FF
		OUT	DDRB,TEMPA	;PORTB OUT
		LDI	TEMPA,$FF
		OUT	DDRC,TEMPA	;PORTC OUT
		LDI	TEMPA,$FF
		OUT	DDRD,TEMPA	;PORTD OUT

;*** LCD INIT ****************************************************
		LDI	TEMPA,$50	;250uS*80=20mS
		RCALL	TIMER		;(DATA,SUB-2)
INITLCD:	LDI	TEMPA,$3F	;INITAL DATA
		RCALL	LCD8SO		;LCD 8BIT OUT(DATA-2)
		LDI	TEMPA,$14	;250uS*20=5mS
		RCALL	TIMER		;(DATA,SUB-2)
		LDI	TEMPA,$3F
		RCALL	LCD8SO		;(DATA-2)
		LDI 	TEMPA,$01	;250uS
		RCALL	TIMER		;(DATA,SUB-2)
		LDI	TEMPA,$3F
		RCALL	LCD8SO		;(DATA-2)
		LDI	TEMPA,$01	;250uS
		RCALL	TIMER		;(DATA,SUB-2)
		LDI	TEMPA,$2F
		RCALL	LCD8SO		;(DATA-2)
		RCALL	BUSY		;(TEMP-2)
		LDI	TEMPA,$28	;2GYO,5*7
		RCALL	LCD4SO		;(DATA,SUB-2)
		RCALL	BUSY		;(TEMP-2)
		LDI	TEMPA,$0E	;LCD ON CURSOL ON,NO-BRINC 
		RCALL	LCD4SO		;(DATA,SUB-2)

;*** DISP DATA INIT **********************************************
TENS:		RCALL	BUSY
		LDI	TEMPA,$80	;SPACE ADDRESS SET
		RCALL	LCD4SO
		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,$8D	;[MHz] ADDRESS SET
		RCALL	LCD4SO
		LDI	TEMPA,'M'	;M
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'H'	;H
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'z'	;z
		RCALL	BUSY
		RCALL	LCD4RO

;*** FREQUENCY DATA SET  ****************************************
		LDI	TEMPA,$35	;50.000.00000
		MOV	AR0,TEMPA
		LDI	TEMPA,$30
		MOV	AR1,TEMPA
		MOV	AR2,TEMPA
		MOV	AR3,TEMPA
		MOV	AR4,TEMPA
		MOV	AR5,TEMPA
		MOV	AR6,TEMPA
		MOV	AR7,TEMPA
		MOV	AR8,TEMPA
		MOV	AR9,TEMPA

;*** ATT DATA SET  **********************************************
		LDI	ATT,$00		;ATT 0dB
		LDI	DBM,$03		;OUTPUT LEVEL -3dBm
		LDI	DBU,$B0		;OUTPUT LEVEL 110dBu

;*** SG SET *****************************************************
		RCALL	HCNV
		SBI	PORTD,3		;RESET DDS
		CBI	PORTD,3
		RCALL	DDSSND
		RCALL	DDSSND		;2KAI SEND SINAITO DDS DOUSASINAI
		RCALL	DISPFRQ
		RCALL	DISPOUT
		RCALL	ATTSET

;*** SWIN SET ***************************************************
		RCALL	SWIN_A		;SWIN FLAG SET
		LDI	TEMPA,$00	;

;****  M A I N ********************************************************************
MAIN:		RCALL	SWIN_A
		CPI	TEMPA,$01
		BREQ	MAIN_FRQ_UP	;FRQ UP
		CPI	TEMPA,$02
		BREQ	MAIN_FRQ_DN	;FRQ DOWN
		RCALL	SWIN_B
		CPI	TEMPA,$01
		BREQ	MAIN_OUT_UP	;OUTPUT UP
		CPI	TEMPA,$02
		BREQ	MAIN_OUT_DN	;OUTPUT DOWN
		RCALL	SWIN_C
		CPI	TEMPA,$01
		BREQ	MAIN_STEP_UP	;FRQ STEP UP
		CPI	TEMPA,$02
		BREQ	MAIN_STEP_DN	;FRQ STEP DOWN
		RJMP	MAIN_END

MAIN_FRQ_UP:	RCALL	FRQUP
		RCALL	MAXCK
		RCALL	DISPFRQ
		RCALL	HCNV
		RCALL	DDSSND
		RJMP	MAIN_END
MAIN_FRQ_DN:	RCALL	FRQDN
		RCALL	MINCK
		RCALL	DISPFRQ
		RCALL	HCNV
		RCALL	DDSSND
		RJMP	MAIN_END

MAIN_OUT_UP:	RCALL	OUTUP
		RCALL	DISPOUT
		RCALL	ATTSET
		RJMP	MAIN_END
MAIN_OUT_DN:	RCALL	OUTDN
		RCALL	DISPOUT
		RCALL	ATTSET
		RJMP	MAIN_END

MAIN_STEP_UP:	RCALL	STEP_UP
		RCALL	DISPFRQ
		RCALL	HCNV
		RCALL	DDSSND
		RJMP	MAIN_END

MAIN_STEP_DN:	RCALL	STEP_DN
		RJMP	MAIN_END

MAIN_END:	RJMP	MAIN

;*************** SUBURUTIN ********************************************************

;*** ROTARY ENCODER SW IN ***************************************
SWIN_A:		CPI	FLAG_A,$00
		BREQ	SWIN_A_0	;OLD DATA 0
		CPI	FLAG_A,$01
		BREQ	SWIN_A_1	;OLD DATA 1
		CPI	FLAG_A,$02
		BREQ	SWIN_A_2	;OLD DATA 2
SWIN_A_3:	IN	TEMPA,PINA	;OLD DATA 3
		ANDI	TEMPA,$03
		MOV	FLAG_A,TEMPA
		CPI	TEMPA,$01
		BREQ	SWIN_A_DN
		CPI	TEMPA,$02
		BREQ	SWIN_A_UP
		RJMP	SWIN_A_STOP
SWIN_A_1:	IN	TEMPA,PINA	;OLD DATA 1
		ANDI	TEMPA,$03
		MOV	FLAG_A,TEMPA
		CPI	TEMPA,$00
		BREQ	SWIN_A_DN
		CPI	TEMPA,$03	
		BREQ	SWIN_A_UP
		RJMP	SWIN_A_STOP
SWIN_A_2:	IN	TEMPA,PINA	;OLD DATA 2
		ANDI	TEMPA,$03
		MOV	FLAG_A,TEMPA
		CPI	TEMPA,$00
		BREQ	SWIN_A_UP
		CPI	TEMPA,$03
		BREQ	SWIN_A_DN
		RJMP	SWIN_A_STOP
SWIN_A_0:	IN	TEMPA,PINA	;OLD DATA 0
		ANDI	TEMPA,$03
		MOV	FLAG_A,TEMPA
		CPI	TEMPA,$01
		BREQ	SWIN_A_UP
		CPI	TEMPA,$02
		BREQ	SWIN_A_DN
		RJMP	SWIN_A_STOP
SWIN_A_UP:	LDI	TEMPA,$01
		RJMP	SWIN_A_END
SWIN_A_DN:	LDI	TEMPA,$02
		RJMP	SWIN_A_END
SWIN_A_STOP:	LDI	TEMPA,$00
SWIN_A_END:	RET

;*** ROTARY ENCODER SW IN ***************************************
SWIN_B:		LDI	TEMPC,$01
		MOV	ATTIMER,TEMPC

		IN	TEMPA,PINA		;C0
		ANDI	TEMPA,$C0
		CPI	TEMPA,$C0
		BREQ	SWIN_B_1
		CPI	TEMPA,$40
		BREQ	SWIN_B_UP
		CPI	TEMPA,$80
		BREQ	SWIN_B_DN
SWIN_B_1:	RJMP	SWIN_B_END

SWIN_B_UP:	IN	TEMPA,PINA		;40
		ANDI	TEMPA,$C0
		CPI	TEMPA,$40
		BREQ	SWIN_B_UP
		CPI	TEMPA,$00
		BREQ	SWIN_B_UP1
		CPI	TEMPA,$C0
		BREQ	SWIN_B
		RJMP	SWIN_B_END
SWIN_B_UP1:	IN	TEMPA,PINA		;00
		ANDI	TEMPA,$C0
		CPI	TEMPA,$00
		BREQ	SWIN_B_UP1
		CPI	TEMPA,$80
		BREQ	SWIN_B_UP2
		CPI	TEMPA,$40
		BREQ	SWIN_B_UP
		RJMP	SWIN_B_END
SWIN_B_UP2:	IN	TEMPA,PINA		;80
		ANDI	TEMPA,$C0
		CPI	TEMPA,$80
		BREQ	SWIN_B_UP2
		CPI	TEMPA,$C0
		BREQ	SWIN_B_UP3
		CPI	TEMPA,$00
		BREQ	SWIN_B_UP1
		RJMP	SWIN_B_END
SWIN_B_UP3:	LDI	TEMPA,$01		;C0
		RJMP	SWIN_B_END

SWIN_B_DN:	IN	TEMPA,PINA		;80
		ANDI	TEMPA,$C0
		CPI	TEMPA,$80
		BREQ	SWIN_B_DN
		CPI	TEMPA,$00
		BREQ	SWIN_B_DN1
		CPI	TEMPA,$C0
		BREQ	SWIN_B
		RJMP	SWIN_B_END
SWIN_B_DN1:	IN	TEMPA,PINA		;00
		ANDI	TEMPA,$C0
		CPI	TEMPA,$00
		BREQ	SWIN_B_DN1
		CPI	TEMPA,$40
		BREQ	SWIN_B_DN2
		CPI	TEMPA,$80
		BREQ	SWIN_B_DN
		RJMP	SWIN_B_END
SWIN_B_DN2:	IN	TEMPA,PINA		;40
		ANDI	TEMPA,$C0
		CPI	TEMPA,$40
		BREQ	SWIN_B_DN2
		CPI	TEMPA,$C0
		BREQ	SWIN_B_DN3
		CPI	TEMPA,$00
		BREQ	SWIN_B_DN1
		RJMP	SWIN_B_END
SWIN_B_DN3:	LDI	TEMPA,$02		;C0
		RJMP	SWIN_B_END
SWIN_B_END:	LDI	TEMPC,$00
		MOV	ATTIMER,TEMPC
		CLR	TM_COUNT
		RET
;------------------------------------
ATTIMER:	IN	REG_SAVE,SREG
		OUT	TCNT0,INIT_VALUE
		SBRS	ATTIMER,0
		RJMP	ATTIMER_END
		INC	TM_COUNT
		SBRS	TM_COUNT,6
		RJMP	ATTIMER_END

ATTIMER_1S:	RCALL	BUSY
		LDI	TEMPA,$C0	;LCD ADDRESS SET
		RCALL	LCD4SO

		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'C'	;C
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'H'	;H
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'K'	;K
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'L'	;L
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'E'	;E
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'V'	;V
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'E'	;E
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'L'	;L
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'C'	;C
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'T'	;T
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,'L'	;L
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,' '	;SPACE
		RCALL	BUSY
		RCALL	LCD4RO
		
ATTIMER_END:	OUT	SREG,REG_SAVE
		RETI

;***  SW IN *****************************************************
SWIN_C:		IN	TEMPA,PINA
		ANDI	TEMPA,$0C
		CPI	TEMPA,$08
		BREQ	SWIN_C_UP
		CPI	TEMPA,$04
		BREQ	SWIN_C_DN
		RJMP	SWIN_C_NASI

SWIN_C_UP:	LDI	TEMPA,$08	;2ms
		RCALL	TIMER
		IN	TEMPA,PINA
		ANDI	TEMPA,$0C
		CPI	TEMPA,$08
		BRNE	SWIN_C_NASI
SWIN_C_UP_LOOP:	IN	TEMPA,PINA
		ANDI	TEMPA,$0C
		CPI	TEMPA,$08
		BREQ	SWIN_C_UP_LOOP
		LDI	TEMPA,$01
		RJMP	SWIN_C_END

SWIN_C_DN:	LDI	TEMPA,$08	;2ms
		RCALL	TIMER
		IN	TEMPA,PINA
		ANDI	TEMPA,$0C
		CPI	TEMPA,$04
		BRNE	SWIN_C_NASI

SWIN_C_DN_LOOP:	IN	TEMPA,PINA
		ANDI	TEMPA,$0C
		CPI	TEMPA,$04
		BREQ	SWIN_C_DN_LOOP
		LDI	TEMPA,$02
		RJMP	SWIN_C_END

SWIN_C_NASI:	LDI	TEMPA,$00

SWIN_C_END:	RET

;*** STEP UP ****************************************************
STEP_UP:	INC	STEP
		CPI	STEP,$06
		BRNE	STEP_UP_0
		LDI	STEP,$05

STEP_UP_0:	LDI	TEMPA,$30
		CPI	STEP,$05
		BREQ	STEP_UP_05
		CPI	STEP,$04
		BREQ	STEP_UP_04
		CPI	STEP,$03
		BREQ	STEP_UP_03
		CPI	STEP,$02
		BREQ	STEP_UP_02
		CPI	STEP,$01
		BREQ	STEP_UP_01

STEP_UP_05:	MOV	AR3,TEMPA
STEP_UP_04:	MOV	AR4,TEMPA
STEP_UP_03:	MOV	AR5,TEMPA
STEP_UP_02:	MOV	AR6,TEMPA
STEP_UP_01:	MOV	AR7,TEMPA
STEP_UP_END:	RET

;*** STEP DOWN **************************************************
STEP_DN:	DEC	STEP
		CPI	STEP,$FF
		BRNE	STEP_DN_END
		LDI	STEP,$00
STEP_DN_END:	RCALL	DSP_STEP
		RET

;*** OUTPUT UP **************************************************
OUTUP:		CPI	ATT,$00
		BREQ	OUTUP_END
		DEC	ATT
		CPI	ATT,$5F
		BRNE	OUTUP_DBM
		LDI	ATT,$3F
OUTUP_DBM:	DEC	DBM
		MOV	TEMPA,DBM
		ANDI	TEMPA,$0F
		CPI	TEMPA,$0F
		BRNE	OUTUP_DBU
		SUBI	DBM,$06

OUTUP_DBU:	INC	DBU
		MOV	TEMPA,DBU
		ANDI	TEMPA,$0F
		CPI	TEMPA,$0A
		BRNE	OUTDN_END
		LDI	TEMPA,$06
		ADD	DBU,TEMPA

OUTUP_END:	RET

;*** OUTPUT DOWN ************************************************
OUTDN:		CPI	ATT,$7F
		BREQ	OUTDN_END
		INC	ATT
		CPI	ATT,$40	
		BRNE	OUTDN_DBM
		LDI	ATT,$60
OUTDN_DBM:	INC	DBM
		MOV	TEMPA,DBM
		ANDI	TEMPA,$0F
		CPI	TEMPA,$0A
		BRNE	OUTDN_DBU
		LDI	TEMPA,$06
		ADD	DBM,TEMPA

OUTDN_DBU:	DEC	DBU
		MOV	TEMPA,DBU
		ANDI	TEMPA,$0F
		CPI	TEMPA,$0F
		BRNE	OUTDN_END
		SUBI	DBU,$06
	
OUTDN_END:	RET

;*** MAX FRQ CHK ************************************************
MAXCK:		MOV	TEMPA,AR0	;MAX FRQ=60MHz
		CPI	TEMPA,$36
		BRNE	MAXCK_END
		LDI	TEMPA,$30
		MOV	AR1,TEMPA
		MOV	AR2,TEMPA
		MOV	AR3,TEMPA
		MOV	AR4,TEMPA
		MOV	AR5,TEMPA
		MOV	AR6,TEMPA
		MOV	AR7,TEMPA
		MOV	AR8,TEMPA
		MOV	AR9,TEMPA
MAXCK_END:	RET

;*** MIN FRQ CHK *************************************************
MINCK:		MOV	TEMPA,AR0	;MIN FRQ=300KHz
		CPI	TEMPA,$30
		BRNE	MINCK_END
		MOV	TEMPA,AR1
		CPI	TEMPA,$30
		BRNE	MINCK_END
		MOV	TEMPA,AR2
		CPI	TEMPA,$32
		BRNE	MINCK_END
		LDI	TEMPA,$33
		MOV	AR2,TEMPA
		LDI	TEMPA,$30
		MOV	AR3,TEMPA
		MOV	AR4,TEMPA
		MOV	AR5,TEMPA
		MOV	AR6,TEMPA
		MOV	AR7,TEMPA
		MOV	AR8,TEMPA
		MOV	AR9,TEMPA
MINCK_END:	RET

;*** FRQ UP ******************************************************
FRQUP:		CPI	STEP,$00
		BREQ	FRQUP_1
		CPI	STEP,$01
		BREQ	FRQUP_10
		CPI	STEP,$02
		BREQ	FRQUP_100
		CPI	STEP,$03
		BREQ	FRQUP_1K
		CPI	STEP,$04
		BREQ	FRQUP_10K
		CPI	STEP,$05
		BREQ	FRQUP_100K

FRQUP_1:	LDI	ZL,$07
		RJMP	FRQUP_LOOP
FRQUP_10:	LDI	ZL,$06
		RJMP	FRQUP_LOOP
FRQUP_100:	LDI	ZL,$05
		RJMP	FRQUP_LOOP
FRQUP_1K:	LDI	ZL,$04
		RJMP	FRQUP_LOOP
FRQUP_10K:	LDI	ZL,$03
		RJMP	FRQUP_LOOP
FRQUP_100K:	LDI	ZL,$02

FRQUP_LOOP:	RCALL	FRQUP_SUB
		CPI	ZL,$FF
		BRNE	FRQUP_LOOP
FRQUP_END:		RET

;--------------------------------
FRQUP_SUB:	LD	TEMPA,Z
		INC	TEMPA
		CPI	TEMPA,$3A
		BRNE	FRQUP_SUB_1
		LDI	TEMPA,$30	;ZERO SET
		ST	Z,TEMPA
		DEC	ZL
		RJMP	FRQUP_SUB_2
FRQUP_SUB_1:	ST	Z,TEMPA
		LDI	ZL,$FF
		CLC			;CLEAR CARRY
		RJMP	FRQUP_SUB_END	
FRQUP_SUB_2:	SEC			;SET CARRY
FRQUP_SUB_END:	RET

;*** FRQ DN *****************************************************
FRQDN:		CPI	STEP,$00
		BREQ	FRQDN_1
		CPI	STEP,$01
		BREQ	FRQDN_10
		CPI	STEP,$02
		BREQ	FRQDN_100
		CPI	STEP,$03
		BREQ	FRQDN_1K
		CPI	STEP,$04
		BREQ	FRQDN_10K
		CPI	STEP,$05
		BREQ	FRQDN_100K

FRQDN_1:	LDI	ZL,$07
		RJMP	FRQDN_LOOP
FRQDN_10:	LDI	ZL,$06
		RJMP	FRQDN_LOOP
FRQDN_100:	LDI	ZL,$05
		RJMP	FRQDN_LOOP
FRQDN_1K:	LDI	ZL,$04
		RJMP	FRQDN_LOOP
FRQDN_10K:	LDI	ZL,$03
		RJMP	FRQDN_LOOP
FRQDN_100K:	LDI	ZL,$02

FRQDN_LOOP:	RCALL	FRQDN_SUB
		CPI	ZL,$FF
		BRNE	FRQDN_LOOP
FRQDN_END:	RET

;------------------------------------
FRQDN_SUB:	LD	TEMPA,Z
		DEC	TEMPA
		CPI	TEMPA,$2F
		BRNE	FRQDN_SUB_1
		LDI	TEMPA,$39	;NINE SET
		ST	Z,TEMPA
		DEC	ZL
		RJMP	FRQDN_SUB_2
FRQDN_SUB_1:	ST	Z,TEMPA
		LDI	ZL,$FF
		CLC			;CLEAR CARRY
		RJMP	FRQDN_SUB_END
FRQDN_SUB_2:	SEC
FRQDN_SUB_END:	RET

;*** DISP FRQ ****************************************************
DISPFRQ:	RCALL	BUSY
		LDI	TEMPA,$83	;FREQ ADDRESS SET
		RCALL	LCD4SO
		LDI	ZL,$00
		RCALL	DCALL
		INC	ZL
		RCALL	DCALL
		LDI	TEMPA,'.'
		RCALL	BUSY
		RCALL	LCD4RO
		INC	ZL
		RCALL	DCALL
		INC	ZL
		RCALL	DCALL
		INC	ZL
		RCALL	DCALL
		LDI	TEMPA,','
		RCALL	BUSY
		RCALL	LCD4RO
		INC	ZL
		RCALL	DCALL
		INC	ZL
		RCALL	DCALL
		INC	ZL
		RCALL	DCALL

		RCALL	DSP_STEP

DISPFRQ_END:	RET

;------------------------------------------
DCALL:		LD	TEMPA,Z
		RCALL	BUSY
		RCALL	LCD4RO
		RET

;*** DISP OUTPUT LEVEL ******************************************
DISPOUT:	RCALL	BUSY
		LDI	TEMPA,$C0	;2GYOUME 0MOJIME ADDRESS SET
		RCALL	LCD4SO

		RCALL	BUSY
		LDI	TEMPA,'-'	;-
		RCALL	LCD4RO

		MOV	TEMPA,DBM
		SWAP	TEMPA
		ANDI	TEMPA,$0F
		ORI	TEMPA,$30
		RCALL	BUSY
		RCALL	LCD4RO

		MOV	TEMPA,DBM
		ANDI	TEMPA,$0F
		ORI	TEMPA,$30
		RCALL	BUSY
		RCALL	LCD4RO

		RCALL	BUSY
		LDI	TEMPA,'d'	;d
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,'B'	;B
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,'m'	;m
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,' '	;SPACE
		RCALL	LCD4RO

DISPOUT_110:	CPI	DBU,$B0		;110dBu
		BRNE	DISPOUT_100
		LDI	TEMPA,$31
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,$31
		RCALL	BUSY
		RCALL	LCD4RO
		RJMP	DISPOUT_1

DISPOUT_100:	MOV	TEMPA,DBU
		ANDI	TEMPA,$F0
		CPI	TEMPA,$A0	;100dBu
		BRNE	DISPOUT_90
		LDI	TEMPA,$31
		RCALL	BUSY
		RCALL	LCD4RO
		LDI	TEMPA,$30
		RCALL	BUSY
		RCALL	LCD4RO
		RJMP	DISPOUT_1

DISPOUT_90:	LDI	TEMPA,$20	;100KETA WO DEL
		RCALL	BUSY
		RCALL	LCD4RO

DISPOUT_10:	MOV	TEMPA,DBU
		SWAP	TEMPA
		ANDI	TEMPA,$0F
		ORI	TEMPA,$30
		RCALL	BUSY
		RCALL	LCD4RO

DISPOUT_1:	MOV	TEMPA,DBU
		ANDI	TEMPA,$0F
		ORI	TEMPA,$30
		RCALL	BUSY
		RCALL	LCD4RO

		RCALL	BUSY
		LDI	TEMPA,'d'	;d
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,'B'	;B
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,$E4	;MICRO
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,' '	;SPACE
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,' '	;SPACE
		RCALL	LCD4RO
		RCALL	BUSY
		LDI	TEMPA,' '	;SPACE
		RCALL	LCD4RO

		RCALL	DSP_STEP
DISPOUT_END:	RET

;*** ATT SET ****************************************************
ATTSET:		OUT	PORTC,ATT
ATTAET_END:	RET

;*** DSP STEP ***************************************************
DSP_STEP:	CPI	STEP,$00
		BREQ	DSP_STEP_00
		CPI	STEP,$01
		BREQ	DSP_STEP_01
		CPI	STEP,$02
		BREQ	DSP_STEP_02
		CPI	STEP,$03
		BREQ	DSP_STEP_03
		CPI	STEP,$04
		BREQ	DSP_STEP_04
		CPI	STEP,$05
		BREQ	DSP_STEP_05

DSP_STEP_00:	RCALL	BUSY
		LDI	TEMPA,$8C
		RCALL	LCD4SO
		RJMP	DSP_STEP_END
DSP_STEP_01:	RCALL	BUSY
		LDI	TEMPA,$8B
		RCALL	LCD4SO
		RJMP	DSP_STEP_END
DSP_STEP_02:	RCALL	BUSY
		LDI	TEMPA,$8A
		RCALL	LCD4SO
		RJMP	DSP_STEP_END
DSP_STEP_03:	RCALL	BUSY
		LDI	TEMPA,$88
		RCALL	LCD4SO
		RJMP	DSP_STEP_END
DSP_STEP_04:	RCALL	BUSY
		LDI	TEMPA,$87
		RCALL	LCD4SO
		RJMP	DSP_STEP_END
DSP_STEP_05:	RCALL	BUSY
		LDI	TEMPA,$86
		RCALL	LCD4SO
		RJMP	DSP_STEP_END

DSP_STEP_END:	RET

;*** DDS SENDING DATA ********************************************
DDSSND:		LDI	ZL,$16		;LOOK UP POINT LSB
		CBI	PORTD,0		;STB
		SBI	PORTB,7		;DATA
		SBI	PORTB,6		;SCK
OUTDDS:		LD	TEMPA,Z
		LDI	TEMPC,$08
		RCALL	DOUT		;DDS LSB 1ST DATA
		DEC	ZL
		LD	TEMPA,Z
		LDI	TEMPC,$08
		RCALL	DOUT		;DDS LSB 2ND DATA
		DEC	ZL
		LDI	TEMPC,$08
		LD	TEMPA,Z
		RCALL	DOUT		;DDS LSB 3RD DATA
		DEC	ZL
		LDI	TEMPC,$08
		LD	TEMPA,Z
		RCALL	DOUT		;DDS MSB DATA
		LDI	TEMPA,$01	;*3 MODE
		LDI	TEMPC,$08
		RCALL	DOUT		;DOUT
		DEC	ZL
		CBI	PORTB,6
		CBI	PORTB,7
		SBI	PORTD,0
		CBI	PORTD,0
DDSE:		RET

;-----------------------------------------------------
DOUT:		NOP
DOUT1:		CBI	PORTD,1
		ROR	TEMPA
		BRCS	SET1		;IF CARRY BIT=1 JUMP 
		CBI	PORTD,2		;CARRY CLEARED
DOUT2:		SBI	PORTD,1
		DEC	TEMPC
		BREQ	EOUT		;8BIT END
		RJMP	DOUT1
SET1:		SBI	PORTD,2
		RJMP	DOUT2
EOUT:		RET

;*** HEX CONV ****************************************************
HCNV:		LDI	TEMPA,$00	;W31=0
		MOV	DAR3,TEMPA
		MOV	DAR2,TEMPA
		MOV	DAR1,TEMPA
		MOV	DAR0,TEMPA
		LDI	R30,$60
		LDI	R31,$00
		MOV	TEMPA,AR0
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR0=0060
		MOV	TEMPA,AR1
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR1=0061
		MOV	TEMPA,AR2
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR2=0062
		MOV	TEMPA,AR3
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR3=0063
		MOV	TEMPA,AR4
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR4=0064
		MOV	TEMPA,AR5
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR5=0065
		MOV	TEMPA,AR6
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR6=0066
		MOV	TEMPA,AR7
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR7=0067
		MOV	TEMPA,AR8
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR6=0068
		MOV	TEMPA,AR9
		ANDI	TEMPA,$0F
		ST	Z+,TEMPA	;BR7=0069

		LDI	R30,$6A
		LDI	R31,$00
		LDI	TEMPA,$04
		ST	Z+,TEMPA	;CR0=006A  SET CLOCK/4 =4
		LDI	TEMPA,$05
		ST	Z+,TEMPA	;CR1=006B  =5
		LDI	TEMPA,$00
		ST	Z+,TEMPA	;CR2=006C  =0
		ST	Z+,TEMPA	;CR3=006D  =0
		ST	Z+,TEMPA	;CR4=006E  =0
		LDI	TEMPA,$00
		ST	Z+,TEMPA	;CR5=006F  =0
		LDI	TEMPA,$00
		ST	Z+,TEMPA	;CR6=0070  =0
		ST	Z+,TEMPA	;CR7=0071  =0
		LDI	TEMPA,$00
		ST	Z+,TEMPA	;CR8=0072  =0
		ST	Z+,TEMPA	;CR9=0073  =0

HCNV_W30:	RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W30_CD	
		RJMP	HCNV_W30_BD
HCNV_W30_CD:	RJMP	HCNV_W29
HCNV_W30_BD:	ORI	DAR0,$40	;W30 BIT ON
		RCALL	HCNV_BMC
HCNV_W29:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W29_CD	
		RJMP	HCNV_W29_BD
HCNV_W29_CD:	RJMP	HCNV_W28
HCNV_W29_BD:	ORI	DAR0,$20	;W29 BIT ON
		RCALL	HCNV_BMC
HCNV_W28:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W28_CD	
		RJMP	HCNV_W28_BD
HCNV_W28_CD:	RJMP	HCNV_W27
HCNV_W28_BD:	ORI	DAR0,$10	;W28 BIT ON
		RCALL	HCNV_BMC
HCNV_W27:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W27_CD	
		RJMP	HCNV_W27_BD
HCNV_W27_CD:	RJMP	HCNV_W26
HCNV_W27_BD:	ORI	DAR0,$08	;W27 BIT ON
		RCALL	HCNV_BMC
HCNV_W26:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W26_CD
		RJMP	HCNV_W26_BD
HCNV_W26_CD:	RJMP	HCNV_W25
HCNV_W26_BD:	ORI	DAR0,$04	;W26 BIT ON
		RCALL	HCNV_BMC
HCNV_W25:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W25_CD
		RJMP	HCNV_W25_BD
HCNV_W25_CD:	RJMP	HCNV_W24
HCNV_W25_BD:	ORI	DAR0,$02	;W25 BIT ON
		RCALL	HCNV_BMC
HCNV_W24:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W24_CD
		RJMP	HCNV_W24_BD
HCNV_W24_CD:	RJMP	HCNV_W23
HCNV_W24_BD:	ORI	DAR0,$01	;W24 BIT ON
		RCALL	HCNV_BMC
HCNV_W23:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W23_CD
		RJMP	HCNV_W23_BD
HCNV_W23_CD:	RJMP	HCNV_W22
HCNV_W23_BD:	ORI	DAR1,$80	;W23 BIT ON
		RCALL	HCNV_BMC
HCNV_W22:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W22_CD
		RJMP	HCNV_W22_BD
HCNV_W22_CD:	RJMP	HCNV_W21
HCNV_W22_BD:	ORI	DAR1,$40	;W22 BIT ON
		RCALL	HCNV_BMC
HCNV_W21:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W21_CD
		RJMP	HCNV_W21_BD
HCNV_W21_CD:	RJMP	HCNV_W20
HCNV_W21_BD:	ORI	DAR1,$20	;W21 BIT ON
		RCALL	HCNV_BMC
HCNV_W20:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W20_CD
		RJMP	HCNV_W20_BD
HCNV_W20_CD:	RJMP	HCNV_W19
HCNV_W20_BD:	ORI	DAR1,$10	;W20 BIT ON
		RCALL	HCNV_BMC
HCNV_W19:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W19_CD
		RJMP	HCNV_W19_BD
HCNV_W19_CD:	RJMP	HCNV_W18
HCNV_W19_BD:	ORI	DAR1,$08	;W19 BIT ON
		RCALL	HCNV_BMC
HCNV_W18:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W18_CD
		RJMP	HCNV_W18_BD
HCNV_W18_CD:	RJMP	HCNV_W17
HCNV_W18_BD:	ORI	DAR1,$04	;W18 BIT ON
		RCALL	HCNV_BMC
HCNV_W17:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W17_CD
		RJMP	HCNV_W17_BD
HCNV_W17_CD:	RJMP	HCNV_W16
HCNV_W17_BD:	ORI	DAR1,$02	;W17 BIT ON
		RCALL	HCNV_BMC
HCNV_W16:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W16_CD
		RJMP	HCNV_W16_BD
HCNV_W16_CD:	RJMP	HCNV_W15
HCNV_W16_BD:	ORI	DAR1,$01	;W16 BIT ON
		RCALL	HCNV_BMC
HCNV_W15:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W15_CD
		RJMP	HCNV_W15_BD
HCNV_W15_CD:	RJMP	HCNV_W14
HCNV_W15_BD:	ORI	DAR2,$80	;W15 BIT ON
		RCALL	HCNV_BMC
HCNV_W14:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W14_CD
		RJMP	HCNV_W14_BD
HCNV_W14_CD:	RJMP	HCNV_W13
HCNV_W14_BD:	ORI	DAR2,$40	;W14 BIT ON
		RCALL	HCNV_BMC
HCNV_W13:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W13_CD
		RJMP	HCNV_W13_BD
HCNV_W13_CD:	RJMP	HCNV_W12
HCNV_W13_BD:	ORI	DAR2,$20	;W13 BIT ON
		RCALL	HCNV_BMC
HCNV_W12:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W12_CD
		RJMP	HCNV_W12_BD
HCNV_W12_CD:	RJMP	HCNV_W11
HCNV_W12_BD:	ORI	DAR2,$10	;W12 BIT ON
		RCALL	HCNV_BMC
HCNV_W11:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W11_CD
		RJMP	HCNV_W11_BD
HCNV_W11_CD:	RJMP	HCNV_W10
HCNV_W11_BD:	ORI	DAR2,$08	;W11 BIT ON
		RCALL	HCNV_BMC
HCNV_W10:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W10_CD
		RJMP	HCNV_W10_BD
HCNV_W10_CD:	RJMP	HCNV_W09
HCNV_W10_BD:	ORI	DAR2,$04	;W10 BIT ON
		RCALL	HCNV_BMC
HCNV_W09:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W09_CD
		RJMP	HCNV_W09_BD
HCNV_W09_CD:	RJMP	HCNV_W08
HCNV_W09_BD:	ORI	DAR2,$02	;W09 BIT ON
		RCALL	HCNV_BMC
HCNV_W08:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W08_CD
		RJMP	HCNV_W08_BD
HCNV_W08_CD:	RJMP	HCNV_W07
HCNV_W08_BD:	ORI	DAR2,$01	;W08 BIT ON
		RCALL	HCNV_BMC
HCNV_W07:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W07_CD
		RJMP	HCNV_W07_BD
HCNV_W07_CD:	RJMP	HCNV_W06
HCNV_W07_BD:	ORI	DAR3,$80	;W07 BIT ON
		RCALL	HCNV_BMC
HCNV_W06:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W06_CD
		RJMP	HCNV_W06_BD
HCNV_W06_CD:	RJMP	HCNV_W05
HCNV_W06_BD:	ORI	DAR3,$40	;W06 BIT ON
		RCALL	HCNV_BMC
HCNV_W05:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W05_CD
		RJMP	HCNV_W05_BD
HCNV_W05_CD:	RJMP	HCNV_W04
HCNV_W05_BD:	ORI	DAR3,$20	;W05 BIT ON
		RCALL	HCNV_BMC
HCNV_W04:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W04_CD
		RJMP	HCNV_W04_BD
HCNV_W04_CD:	RJMP	HCNV_W03
HCNV_W04_BD:	ORI	DAR3,$10	;W04 BIT ON
		RCALL	HCNV_BMC
HCNV_W03:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W03_CD
		RJMP	HCNV_W03_BD
HCNV_W03_CD:	RJMP	HCNV_W02
HCNV_W03_BD:	ORI	DAR3,$08	;W03 BIT ON
		RCALL	HCNV_BMC
HCNV_W02:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W02_CD
		RJMP	HCNV_W02_BD
HCNV_W02_CD:	RJMP	HCNV_W01
HCNV_W02_BD:	ORI	DAR3,$04	;W02 BIT ON
		RCALL	HCNV_BMC
HCNV_W01:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W01_CD
		RJMP	HCNV_W01_BD
HCNV_W01_CD:	RJMP	HCNV_W00
HCNV_W01_BD:	ORI	DAR3,$02	;W01 BIT ON
		RCALL	HCNV_BMC
HCNV_W00:	RCALL	HCNV_CW2
		RCALL	HCNV_COMP
		CPI	TEMPC,01
		BREQ	HCNV_W00_CD
		RJMP	HCNV_W00_BD
HCNV_W00_CD:	RJMP	HCNV_END
HCNV_W00_BD:	ORI	DAR3,$01	;W00 BIT ON
		RCALL	HCNV_BMC
HCNV_END:	RET

;--------------------------------
HCNV_COMP:	LDI	R30,$60			;BR
		LDI	R31,$00
		LDI	R28,$6A			;CR
		LDI	R29,$00
		LDI	TEMPA,$0A
HCNV_COMP_LOOP:	LD	TEMPB,Z+
		LD	TEMPC,Y+
		CP	TEMPB,TEMPC
		BREQ	HCNV_COMP_NEXT
		BRSH	HCNV_COMP_BD
		RJMP	HCNV_COMP_CD
HCNV_COMP_NEXT:	DEC	TEMPA
		BRBS	1,HCNV_COMP_END
		RJMP	HCNV_COMP_LOOP
HCNV_COMP_CD:	LDI	TEMPC,$01	;C>B
		RJMP	HCNV_COMP_END
HCNV_COMP_BD:	LDI	TEMPC,$02	;C<B
		RJMP	HCNV_COMP_END
HCNV_COMP_EQ:	LDI	TEMPC,$03	;C=B
		RJMP	HCNV_COMP_END
HCNV_COMP_END:	RET

;--------------------------------
HCNV_BMC:	CLC			;CARRY =0
		LDI	R30,$6A		;LOOP NO TUGOU DE +1
		LDI	R31,$00
		LDI	R28,$74		;LOOP NO TUGOU DE +1
		LDI	R29,$00
		LDI	TEMPA,$0A
HCNV_BMC_LOOP:	LD	TEMPB,-Z
		LD	TEMPC,-Y
		SBC	TEMPB,TEMPC
		BRPL	HCNV_BMC_PL
		RCALL	HCNV_BMC_MINU
HCNV_BMC_PL:	ST	Z,TEMPB
		DEC	TEMPA
		BRBS	1,HCNV_BMC_END
		RJMP	HCNV_BMC_LOOP
HCNV_BMC_END:	RET
;------------------------
HCNV_BMC_MINU:	SUBI	TEMPB,$F6
		SEC
		RET

;--------------------------------
;CR0-9 1/2 SUBRUTINE
HCNV_CW2:	LDI	R28,$6A
		LDI	R29,$00
		CLC
		LDI	TEMPA,$0A
HCNV_CW2_LOOP1:	LD	TEMPC,Y
		ROR	TEMPC
		ST	Y+,TEMPC
		DEC	TEMPA
		BRBS	1,HCNV_CW2_NEXT
		RJMP	HCNV_CW2_LOOP1
HCNV_CW2_NEXT:	LDI	R28,$6A
		LDI	R29,$00
		LDI	TEMPA,$0A
HCNV_CW2_LOOP2:	LD	TEMPC,Y
		SBRC	TEMPC,7
		SUBI	TEMPC,$7B		;8Y-7B=0X
		ST	Y+,TEMPC
		DEC	TEMPA
		BRBS	1,HCNV_CW2_END
		RJMP	HCNV_CW2_LOOP2
HCNV_CW2_END:	RET

;***@SUBRUTIN@LCD8SO@*** DATA *********************************
LCD8SO:		CBI	PORTD,5		;RS
		CBI	PORTD,4		;R/W
		SBI	PORTD,6		;E
		OUT	PORTB,TEMPA
		RCALL	WAIT
		CBI	PORTD,6
		RET			;

;***@TEMPRUTIN@LCD4SO@*** DATA,SUB *****************************
LCD4SO:		CBI	PORTD,5		;RS
		CBI	PORTD,4		;R/W
		SBI	PORTD,6		;E
		MOV	TEMPC,TEMPA	
		ORI	TEMPA,$0F	
		OUT	PORTB,TEMPA
		RCALL	WAIT
		CBI	PORTD,6
		CBI	PORTD,5		;RS
		CBI	PORTD,4		;R/W
		SBI	PORTD,6		;E
		SWAP	TEMPC	
		ORI	TEMPC,$0F	
		OUT	PORTB,TEMPC
		RCALL	WAIT
		CBI	PORTD,6
		RET		

;***@SUBRUTIN@LCD4RO@*** DATA,SUB *****************************
LCD4RO:		SBI	PORTD,5		;RS
		CBI	PORTD,4		;R/W
		SBI	PORTD,6		;E
		MOV	TEMPC,TEMPA	
		ORI	TEMPA,$0F	
		OUT	PORTB,TEMPA
		RCALL	WAIT
		CBI	PORTD,6
		SBI	PORTD,5		;RS
		CBI	PORTD,4		;R/W
		SBI	PORTD,6		;E
		SWAP	TEMPC	
		ORI	TEMPC,$0F	
		OUT	PORTB,TEMPC
		RCALL	WAIT
		CBI	PORTD,6
		RET		;

;***@SUBRUTIN@TIMER@*** DATA,SUB ******************************
TIMER:		RCALL	QUS
		DEC	TEMPA
		BRNE	TIMER		
		RET

;-------------------------------------------
QUS:		CLR	TEMPC		;250uS WAIT
LOOP1:		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		NOP
		DEC	TEMPC
		BRNE	LOOP1	
		RET		

;***@SUBRUTIN@BUSY@*** TEMP ***********************************
BUSY:		RCALL	BUSY_INIT_IN
		CBI	PORTD,5		;RS
		SBI	PORTD,4		;R/W
		SBI	PORTD,6		;E
		RCALL	WAIT
LOOP2:		SBIC	PINB,7		;BUSY FLAG
		RJMP	LOOP2
lo:		CBI	PORTD,6
		RCALL	BUSY_INIT_OUT
		RET

;-------------------------------------------
BUSY_INIT_IN:	LDI	TEMPC,$00
		OUT	DDRB,TEMPC
		LDI	TEMPC,$FF
		OUT	PORTB,TEMPC
		RET

;-------------------------------------------
BUSY_INIT_OUT:	LDI	TEMPC,$FF
		OUT	DDRB,TEMPC
		LDI	TEMPC,$FF
		OUT	PORTB,TEMPC
		RET

;*** SUBRUTION	WAIT **********************************************
WAIT:		RET			;CLK *7=1.14uS

;**** End of File ************************************************

